#ifndef __COMMON_H__
#define __COMMON_H__


int min(int a, int b) ;
int max(int a, int b) ;
void copy_int(int *dst, int *src, int count) ;
void copy_float(float *dst, float *src, int count) ;
void reverse_array(int * ar, int length) ;
void reverse_array_float(float * ar, int length) ;

char *read_line(FILE*infile, char* line, size_t max_len) ;
char *reverse_complement(char*in) ;
int find_open_frame(char * seq, int len);
int find_max_open_frame(char * seq, int len, int *pl1, int *pl2, int *pl3);
int find_open_frame_backward(char * seq, int len);
int find_max_open_frame_backward(char * seq, int len, int *pl1, int *pl2, int *pl3);

int check_exon(int contig_num, int start, int end, char ori, 
			   char**pexon, int *porf_len_left, int *porf_len_right) ;
int check_intron(int contig_num, int start, int end, char ori, 
				 int *start_diff, int *end_diff) ;
int check_intron_protein(int contig_num, int start, int end, char ori, 
						 int *start_diff, int *end_diff, int Qgap) ;
int check_intron_revcomp(int contig_num, int start, int end, char ori, 
						 int *start_diff, int *end_diff) ;
int check_intron_simple(int contig_num, int start, int end, char ori);
int get_intron_type(int contig_num, int start, int end, char ori) ;

int get_exon(int contig_num, int start, int end, char ori, 
			 char**pexon) ;
int get_intron(int contig_num, int start, int end, char ori, char **intron) ;

#endif
