#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <assert.h>

#include "common.h"
#include "genome.h"
//#include "est2gff.h"


int main(int argc, char**argv)
{
	int i, what=0 ;
	char * genome_config_fname=NULL ;

	if (argc<2)
	{
		fprintf(stderr, "usage: %s <estfiles|cdnafiles|annotationfiles|basedir> [<genome_config_fname]\n", argv[0]) ;
		exit(-1) ;
	} 

	if (strcmp(argv[1], "estfiles")==0)
		what=1 ;
	else if (strcmp(argv[1], "cdnafiles")==0)
		what=2 ;
	else if (strcmp(argv[1], "basedir")==0)
		what=3 ;
	else if (strcmp(argv[1], "annotationfiles")==0)
		what=4 ;
	else if (strcmp(argv[1], "protfiles")==0)
		what=5 ;
	
	assert( what==1 || what==2 || what==3 || what==4 || what==5 ) ;

	// genome config
	if (argc<3)
		genome_config_fname = "genome.config" ;
	else
		genome_config_fname = argv[2] ;

	// genome initialization
	if (init_genome(genome_config_fname)!=0)
	{
		fprintf(stderr, "genome initialization failed\n") ;
		exit(-1) ;
	}
	
	// output contig fnames
	switch (what)
	{
	case 1:
		for (i=0; i<num_est_files; i++)
			fprintf(stdout, "%s\n", est_fnames[i]) ;
		break ;
	case 2:
		for (i=0; i<num_cdna_files; i++)
			fprintf(stdout, "%s\n", cdna_fnames[i]) ;
		break ;
	case 3:
		fprintf(stdout, "%s\n", basedir) ;
		break ;
	case 4:
		for (i=0; i<num_annotation_files; i++)
			fprintf(stdout, "%s\n", annotation_fnames[i]) ;
		break ;
	case 5:
		for (i=0; i<num_prot_files; i++)
			fprintf(stdout, "%s\n", prot_fnames[i]) ;
		break ;
	}
	
	return 0;
} 

