#ifndef __PENALTY_INFO_H__
#define __PENALTY_INFO_H__

#include "common.h"
#include "Mathmatics.h"

enum ETransformType
{
	T_LINEAR,
	T_LOG,
	T_LOG_PLUS1,
	T_LOG_PLUS3,
	T_LINEAR_PLUS3
}  ;

struct penalty_struct
{
	INT len ;
	REAL *limits ;
	REAL *penalties ;
	INT max_len ;
	INT min_len ;
	REAL *cache ;
	enum ETransformType transform ;
	INT id ;
	struct penalty_struct *next_pen ;
	char * name ;
	INT use_svm ;
} ;

void init_penalty_struct(struct penalty_struct &PEN) ;
void delete_penalty_struct_palma(struct penalty_struct &PEN) ;
//void delete_penalty_struct_array(struct penalty_struct *PEN, INT len) ;
void copy_penalty_struct(struct penalty_struct *old, struct penalty_struct *newp);

//#ifdef HAVE_MATLAB
//struct penalty_struct * read_penalty_struct_from_cell(const mxArray * mx_penalty_info, mwSize &P) ;
//#endif

REAL lookup_penalty(const struct penalty_struct *PEN, INT p_value, 
					REAL* svm_values, bool follow_next=true) ;

enum mode { NORMAL, USE_QUALITY_SCORES};

#endif
