#include "assert.h"
#include "fill_matrix.h"
#include "debug_tools.h"

using namespace std;

void increaseFeatureCount(penalty_struct* qparam, int dnaChar, int estChar, double estprb) {

   FA(estChar > 0 && estChar < 6);
   FA(dnaChar > -1 && dnaChar < 6);

   int currentPos = (estChar-1)*6+dnaChar;

   penalty_struct currentStruct = qparam[currentPos];

   //printf("Current index %d est/dna: %d %d score %f\n",currentPos,estChar,dnaChar,estprb);

   //if( estChar == 1 and dnaChar == 1) {
   //   printf("before\n");
   //   int p_idx;
   //   for(p_idx=0;p_idx<currentStruct.len;p_idx++) {
   //      printf("%f ",currentStruct.limits[p_idx]);
   //   }
   //   printf("\n");

   //   for(p_idx=0;p_idx<currentStruct.len;p_idx++) {
   //      printf("%f ",currentStruct.penalties[p_idx]);
   //   }
   //   printf("\n");
   //}

   double value = estprb;
   int Lower = 0;
   int idx;

   for (idx=0;idx<currentStruct.len;idx++) {
      if (currentStruct.limits[idx] <= value)
         Lower++;
   }

   if (Lower == 0) {
         currentStruct.penalties[0] += 1;
         qparam[currentPos] = currentStruct;
         return;
   }

   if (Lower == currentStruct.len) {
         currentStruct.penalties[currentStruct.len-1] += 1;
         qparam[currentPos] = currentStruct;
         return;
   }

   Lower -= 1;
   int Upper = Lower+1; // x-werte bleiben fest

   double weightup  = 1.0*(value - currentStruct.limits[Lower]) / (currentStruct.limits[Upper] - currentStruct.limits[Lower]);
   double weightlow = 1.0*(currentStruct.limits[Upper] - value) / (currentStruct.limits[Upper] - currentStruct.limits[Lower]);
   currentStruct.penalties[Upper] += weightup;
   currentStruct.penalties[Lower] += weightlow; 

   //if( estChar == 1 and dnaChar == 1) {
   //   printf("estprb/Lower/Upper %f %d %d\n",estprb,Lower,Upper);
   //   int p_idx;
   //   printf("after\n");
   //   for(p_idx=0;p_idx<currentStruct.len;p_idx++) {
   //      printf("%f ",currentStruct.limits[p_idx]);
   //   }
   //   printf("\n");
   //   for(p_idx=0;p_idx<currentStruct.len;p_idx++)
   //      printf("%f ",currentStruct.penalties[p_idx]);
   //   printf("\n");
   //}
   qparam[currentPos] = currentStruct;
}

bool result_align(Pre_score* matrices[], int z, int est_len, int dna_len, int* result_length_ptr, char* est, char* dna, double* prb, double* chastity, int* s_align, int* e_align, int* mparam, double* alignmentscores, int* max_score_positions, penalty_struct* qparam, mode currentMode)
//Gibt 1 zurueck, wenn kein weiterer Pfad existiert, sonst 0

{  
  const int mlen=6; // length of matchmatrix
  int startend[4] ; // [i_start, j_start, i_end, j_end] ;
  startend[3] = max_score_positions[2*z] ; //i (est)
  startend[4] = max_score_positions[2*z +1] ; //j (dna)
  //printf("in result_align: z=%d:(%d, %d)\n", z, startend[3], startend[4]) ;
  int dnanum ; //using check_char: letter -> number
  int estnum ; //using check_char: letter -> number

  double prbnum ;
  double chastitynum ;

  int dna_pos ;
  int est_pos ;
  int splice_state ;
  int est_state ;
  for (dna_pos=dna_len-1; dna_pos>startend[4]; dna_pos--) {
    s_align[dna_pos-1] = 4 ; // not aligned (-1 because array starts with index 0)
  }
  for (est_pos=est_len-1; est_pos>startend[3]; est_pos--) {
    e_align[est_pos-1] = 4 ;
  }
  //splice_align: 0: exon, 1: donor, 2: acceptor, 3: intro,. 4: dangling end

  /* starting point for backtracking */
  int i = startend[3] ; 
  int j = startend[4] ;
  int act_m_no  = z ;
  alignmentscores[z] = ((Pre_score*)matrices[z] + i*dna_len +j)->value;
  //printf("alignment_score for z=%d: %3.8f\n", z, alignmentscores[z]) ;

  int prev_i    = ((Pre_score*)matrices[act_m_no] + i*dna_len +j)->prev_i; 
  int prev_j    = ((Pre_score*)matrices[act_m_no] + i*dna_len +j)->prev_j;
  int prev_m_no = ((Pre_score*)matrices[act_m_no] + i*dna_len +j)->prev_matrix_no;

  //printf("Current z is %d\n",z);

  if(!(isfinite(((Pre_score*)matrices[act_m_no] + i*dna_len +j)->value)))
  {
    cout << "No additional path left (inf)!\n";
    return 1;
  }

  if(((Pre_score*)matrices[act_m_no] + i*dna_len +j)->value==0) {
    cout << "No additional path left (0)!\n";
    return 1;
  }

  assert(dna_pos == j) ;
  assert(est_pos == i) ;

  splice_state = 0 ; //exon
  est_state = 1 ; //[112222111 ... for exons of length 2,4,3 ...

  //compute length of alignment (between max(m,n) and m+n)	
  //local_alignment: backtracking to first Zero: look at actual value
  while(!(((Pre_score*)matrices[act_m_no] + i*dna_len +j)->value)==0.0) {
    
    //just some info
    //if ((z>0) && (!(z==prev_m_no))) {
    //  printf("(%d,%d): next step in next matrix\n", i,j) ;
    //}

    if ((prev_i == (i-1)) && (prev_j == (j-1))) { // match or mismatch
      (*result_length_ptr)= (*result_length_ptr) + 1;
      
      s_align[dna_pos-1] = splice_state; 
      dna_pos-- ;
      e_align[est_pos-1] = est_state ; //1 or 2, depended
      est_pos-- ;
      
      dnanum = check_char(dna[j-1]) ; //-1 because index starts with 0
      estnum = check_char(est[i-1]) ; //-1 because index starts with 0

      prbnum = prb[i-1];
      chastitynum = chastity[i-1];

      //printf("Position %d,%d est,dna: %d,%d\n",i,j,estnum,dnanum);

      if(currentMode == USE_QUALITY_SCORES)
         increaseFeatureCount(qparam,dnanum,estnum,prbnum);
      else
         mparam[mlen*dnanum+estnum] ++ ;

    }
    else if ((prev_i == (i)) && (prev_j == (j-1))) {// gap on EST
      (*result_length_ptr)= (*result_length_ptr) + 1;
      
      s_align[dna_pos-1] = splice_state; 
      dna_pos-- ;

      dnanum = check_char(dna[j-1]) ; //-1 because index starts with 0
      estnum = 0 ; //gap

      if(currentMode == USE_QUALITY_SCORES)
         mparam[dnanum] ++ ;
      else
         mparam[mlen*dnanum +estnum] ++ ;

    }
    else if ((prev_i == (i-1)) && (prev_j == (j))) { // gap on DNA
      (*result_length_ptr)= (*result_length_ptr) + 1;
      
      e_align[est_pos-1] = est_state ;  //1 or 2, depended
      est_pos-- ;

      dnanum = 0 ; //gap
      estnum = check_char(est[i-1]) ; //-1 because index starts with 0

      prbnum = prb[i-1];
      chastitynum = chastity[i-1];

      //printf("Position %d,%d est,dna: %d,%d\n",i,j,estnum,dnanum);

      if(currentMode == USE_QUALITY_SCORES)
         increaseFeatureCount(qparam,dnanum,estnum,prbnum);
      else
         mparam[mlen*dnanum +estnum] ++ ;
    }
    else {// splice site
      (*result_length_ptr) =  (*result_length_ptr) + (j - prev_j);
      if (((Pre_score*)matrices[act_m_no] + i*dna_len + j)->issplice==0) {
	printf("matrices[act_m_no](i,j): %3.15f\n",((Pre_score*)matrices[act_m_no] + i*dna_len +j)->value) ;
	printf("matrices[prev_m_no](i,j): %3.15f\n",((Pre_score*)matrices[prev_m_no] + i*dna_len +j)->value) ;
	printf("issplice(act): %d\n",((Pre_score*)matrices[act_m_no] + i*dna_len + j)->issplice) ;
	printf("issplice(prev): %d\n",((Pre_score*)matrices[prev_m_no] + i*dna_len + j)->issplice) ;
	printf("act_m_no: %d, prev_m_no: %d\n", act_m_no, prev_m_no) ;
	printf("j: %d -> prev_j:%d\n", j, prev_j) ;
	printf("i: %d -> prev_i:%d\n", i, prev_i) ;
      }
      if (est_state==1) { //was exon labeled "1"
	est_state = 2 ; //new exon is labeled "2"
      }
      else {
	est_state = 1 ; //last exon was labeled "2", new exon is labeled "1"
      }
      for (; j > prev_j; j--) {
	if (splice_state == 0) { //coming from exon
	  splice_state = 2 ; //first intron_state: acceptor
	} else {
	  splice_state = 3 ; //intron
	}
	if (j-1 == prev_j) { //last intron_state: donor
	  splice_state = 1 ;//donor
	}
	s_align[dna_pos-1] = splice_state; 
	dna_pos-- ;
      }
      splice_state = 0 ; //exon again
      
    }
   
    startend[1] = i;
    startend[2] = j;
    i = prev_i;
    j = prev_j;
    act_m_no = prev_m_no ;
    
    prev_i    = ((Pre_score*)matrices[act_m_no] + i*dna_len + j)->prev_i; 
    prev_j    = ((Pre_score*)matrices[act_m_no] + i*dna_len + j)->prev_j; 
    prev_m_no = ((Pre_score*)matrices[act_m_no] + i*dna_len +j)->prev_matrix_no;
  }
  for (; dna_pos>0; dna_pos--) {
    s_align[dna_pos-1] = 4 ; // not aligned (-1 because array starts with index 0)
  }
  for (; est_pos>0; est_pos--) {
    e_align[est_pos-1] = 4 ; // not aligned (-1 because array starts with index 0)
  }

  //printf("(%d, %d) --> (%d, %d)\n", startend[1], startend[2], startend[3], startend[4]) ;
  //printf("result_length: %d\n", *result_length_ptr) ;
  return 0;
}
