#!/usr/bin/env python 
# -*- coding: utf-8 -*-

import sys
import os.path
import cPickle
import csv
from Solexa import Read

def parse(solexa_fid,pickle_fid):
   
   reader = csv.reader(solexa_fid, delimiter='\t', quoting=csv.QUOTE_NONE)

   allReads = []
   currentRead = None

   stmap = {'P':'-','D':'+'}

   for row in reader:
      assert len(row) == 12
      chr = row[0]
      pos = row[1]
      seq = row[2]
      id = int(row[3])
      strand = stmap[row[4]]
      mismatch = row[5]
      repeat = row[6]
      length = row[7]
      deletion = row[8]

      prob = row[9]
      calibratedProb = row[10]
      chastity = row[11]

      prob = [ord(elem)-50 for elem in prob]
      calibratedProb = [ord(elem)-64 for elem in calibratedProb]
      chastity = [ord(elem)+10 for elem in chastity]

      currentRead = Read(chr,pos,seq,strand,prob,calibratedProb,chastity)
      allReads.append(currentRead)

   cPickle.dump(allReads,pickle_fid)

if __name__ == '__main__':
   assert len(sys.argv) >= 3
   solexaFile = sys.argv[1]
   pickleFile = sys.argv[2]
   assert os.path.exists(solexaFile)
   assert not os.path.exists(pickleFile)

   solexa_fid = open(solexaFile)
   pickle_fid = open(pickleFile,'w+')
   parse(solexa_fid,pickle_fid)
