#!/usr/bin/env python 
# -*- coding: utf-8 -*-

import array
import os.path
import sys

mes = 'Usage: python asciispf_to_spf.py infile outfile'

def convert2binary(in_fn,out_fn):
   """
   """

   # count number of lines
   file_content = open(in_fn).read()
   size = len([e for e in file_content if e == '\n'])
   
   positions   = array.array('I',[0]*size)
   scores      = array.array('f',[0.0]*size)

   for idx,line in enumerate(open(in_fn)):
      line.strip()
      pos,score = line.split(' ')
      pos = int(pos)
      score = float(score)

      positions[idx] = pos
      scores[idx]    = score
      
   positions.tofile(open('%s.pos'%out_fn,'wb'))
   scores.tofile(open('%s.Conf'%out_fn,'wb'))


if __name__ == '__main__':
   if len(sys.argv)-1 != 2:
      print mes

   filename = sys.argv[1]
   assert os.path.exists(filename), mes

   out_filename = sys.argv[2]

   convert2binary(filename,out_filename)
